Subject: Re: bug#40839: Shepherd activation .GO files are not cross-compiled ... and the Hurd

From: Jan Nieuwenhuizen <[email-masked]>
Date: Tue, 28 Apr 2020 19:20:36 +0200

Mathieu Othacehe writes:

Hello Mathieu!

> I had a look to (gnu system hurd), this is really nice! I think we could
> try an explosive mixture of our two branches :)

Sure, why not? ;-) I played a bit yesterday with wip-disk-image.  Not
that (gnu system hurd) already lives on core-updates; possibly we can
start playing there?  I tried rebasing wip-disk-image on core-updates
and that was (almost?) painless.

> More seriously, we could do something like:
>
> (define hurd-disk-image
>   (image
>    (format 'disk-image)
>    (partitions
>     (list
>      (partition
>       (size 'guess)
>       (label "Guix_image")
>       (file-system "ext2")
>       (flags '(boot))
>       (initializer (gexp initialize-hurd-root-partition)))))))

Sweet!

> then we could have some mapping in guix/scripts/system.scm to
> associate:
>
> * x86_64-linux -> efi-disk-image
> * i586-pc-gnu -> hurd-disk-image
>
> and one could get a hurd disk-image by typing: 
>
> guix system disk-image --target=i586-pc-gnu my-hurd-os.scm

Oh, that sounds real great.

> One problem that can arise is the installation of grub. Currently
> wip-disk-image does not support legacy Grub (MBR based)
> installation.
>
> This is because running grub-install needs root permissions, to mess with
> /dev/something in order to write the MBR I guess.

Hmm...so we need to do some work, is that bad?

> We could also create a Hurd ISO if grub-mkrescue (that is used to make
> the ISO bootable), supports the Hurd.
>
> Adding Ludo that might have some insight here.

Hopefully -- this is also pretty out of my comfort zone, otoh I am
very motivated to get this going. :-)

I have been wondering about the branch name in combination with its
functionality: can/will/could "wip-disk-image" also be used for
guix system init/reconfigure (we don't have qemu on the Hurd)?

Greetings,
janneke

-- 
Jan Nieuwenhuizen <[email-masked]> | GNU LilyPond http://lilypond.org
Freelance IT http://JoyofSource.com | Avatar® http://AvatarAcademy.com